#ifdef	AIX
#define	_BSD
#endif

#include	<stdio.h>
#include	<stdlib.h>

#define MAXLINELENGTH 1024 /* maximum string lengths */
#define MAXFNAME 750	/* max filename length DDD/FILENAME.EXT */
#define MAXHIST  65	/* number of links we remember in history */
#define MAXLINKS 65	/* max links on one screen */
#define	MAXSYMWIN 20	/* window space for form filling */
#define	MAXDBWIN 70	/* DB space for form filling */
#define	MAXSEARCHPATH 10/* maximum alternative paths */
#define	MAXTRIGGERS 20	/* max number of additional triggers in browser */
#ifndef	USEENV
#define MAXSYMS	100	/* max symbols */
#endif
#define	SCREENSIZE	23
#define	PROMPT		23

#define UPARROW	201
#define DNARROW	202
#define RTARROW	203
#define LTARROW	204

#define	min(a,b) (a<b?a:b)
#define	max(a,b) (a<b?b:a)

#define NGOPHERSITE "gopher.wayne.edu"   /* set your default gopher site */
#define NGOPHERPORT 70 			   /* set your default gopher port */

/* You may wish to modify some of these help messages */
#define STARTFILE "start"
#define HELPFILE "help"
#define HELP "Commands: Use arrow keys to move, '?' for help, 'q' to quit"
#define MOREHELP \
  "press SPACE BAR for more, use arrow keys to move, '?' for help, 'q' to quit"
#define MORE "-- press SPACE BAR for more --"
#define FIELDHELP "[Fill in the blank  <CR> to execute ^B file listing  ^G abort]"

#define DEFAULTEDITOR "/usr/local/bin/pico"		/* full path to editor */
#define DEFAULTPAGER "/usr/bin/less"      /* full path to pager */

#define	predefbrowse	"BROWSE"

int screenInit();
void startCurses();
void stopCurses();
#ifdef CURSESX
#define attribCurrent()		attrset(A_REVERSE)
#define attribSelectable()	attrset(A_BOLD)
#define attribStatusLine()	attrset(A_REVERSE)
#define attribInputForm()	attrset(A_UNDERLINE)
#define attribNormal()		attrset(A_NORMAL)
#else
#ifdef	AIX
#define attribCurrent()		attrset(A_REVERSE)
#define attribSelectable()	attrset(A_BOLD)
#define attribStatusLine()	attrset(A_REVERSE)
#define attribInputForm()	attrset(A_UNDERLINE)
#define attribNormal()		attrset(A_NORMAL)
#else
#define attribCurrent()		standout()
#define attribSelectable()	standend()
#define attribStatusLine()	standout()
#define attribInputForm()	standout()
#define attribNormal()		standend()
#endif
#endif

#ifdef  NOPROTO
void setvalue();
void getvalue();
#else
void setvalue(char*, char*);
void getvalue(char*, char*);

void initVariables();
void addSearchPath(char*);
void extendSearchPath(char*);
FILE* fopenWithSearchPath(char*, char*);
char* findWithSearchPath(char*);

char* mx(char*);
#endif

extern char erasech;
extern char ruboutch;
